/* Wir rufen die Seite von IBM und Microsoft auf um den Aktienpreis zu ermitteln. */

say " Wir rufen die Seite von IBM und Microsoft auf um den Aktienpreis zu ermitteln."
say


---------------------------IBM--------------------------------------------

Explorer = .OLEObject~new("InternetExplorer.Application")
Explorer~Visible = .true
Explorer~Navigate("http://www.ibm.com/investor/")



/* obtain text representation of the page */
doc = Explorer~document           -- DOM document
body = doc~body                   -- get BODY
textrange = body~CreateTextRange  -- get TextRange
text = textrange~Text             -- get the contents

/* extract stock price information, this is dependent on page not changing */
parse var text . "(NYSE)" '0d0a'x  stockprice "0d0a"x .
if stockprice = "" then do
    stockprice = "<could not read stock price>"
    gotPrice = .false
end
else do
    gotPrice = .true
end

/* end Explorer */
Explorer~quit

parse var stockprice "$" IBM_Aktienkurs
say "Aktienkurs von IBM= "IBM_Aktienkurs"$."
if \ gotPrice then say "Web page has likely changed format."
call SysSleep 2

---------------Microsoft----------------------------------------------------------

myIE = .OLEObject~New("InternetExplorer.Application")

myIE~Width=1500
myIE~Height=1500

myIE~Visible=.True
myIE~Navigate("https://www.microsoft.com/en-us/investor")
Call SysSleep 3

doc = myIE~document
body=doc~body
textrange=body~CreateTextRange
text=textrange~Text

parse var text . "Microsoft Corp (MSFT)" stockpriceMS "%)" x .
if stockpriceMS = "" then stockpriceMS = "error 404: stock price not found"
myIE~quit

stockpriceMS2 = stockpriceMS"."
parse var stockpriceMS2 "$" MS_Aktienkurs var2
say "Aktienkurs von Microsoft= "MS_Aktienkurs"$."
call SysSleep 2


-----Dollar Euro Kurs-------------------------------

myIE = .OLEObject~New("InternetExplorer.Application")

myIE~Width=1500
myIE~Height=1500

myIE~Visible=.True
myIE~Navigate("https://www.finanzen.at/devisen/dollarkurs")
Call SysSleep 3

doc = myIE~document
body=doc~body
textrange=body~CreateTextRange
text=textrange~Text

parse var text . "(EUR - USD)" ex_rate "USD" x .
if ex_rate = "" then ex_rate = "error 404: exchange rate not found"
myIE~quit

parse var ex_rate name1 10 Wechselkurs 6

Say "Der Wechselkurs ist=" Wechselkurs

parse var Wechselkurs before "," after 

FinaleWK = before"."after

call SysSleep 3

Say ""
Say "Wir erstellen nun eine Excel Tabelle wo wir die Werte einspielen und den Kurs in Euro umrechnen"
Say "Die Tabelle wird am Desktop gespeichert"
call SysSleep 5

-----------------Excel----------------------------------------

excelObjekt = .OLEObject~new("Excel.Application")
excelObjekt~visible = .true
tabellenBlatt = excelObjekt~workbooks~add~worksheets[1]

titel = tabellenBlatt~range("B1")
titel_2 = tabellenBlatt~range("C1")
titel_3 = tabellenBlatt~range("D1")
titel_4 = tabellenBlatt~range("E1")
titel_5 = tabellenBlatt~range("A1")

titel~font~bold = .true
titel_2~font~bold = .true
titel_3~font~bold = .true
titel_4~font~bold = .true
titel_5~font~bold = .true

titel~value = "Aktienkurse USD"
titel_2~value = "Datum"
titel_3~value = "Wechselkurs USD"
titel_4~value = "Aktienkurse EUR"
titel_5~value = "Unternehmen"

tabellenBlatt~cells(2,1)~value = IBM
tabellenBlatt~cells(3,1)~value = Microsoft
tabellenBlatt~cells(2,2)~value = IBM_Aktienkurs
tabellenBlatt~cells(3,2)~value = MS_Aktienkurs
tabellenBlatt~cells(2,3)~value = date()
tabellenBlatt~cells(3,3)~value = date()
tabellenBlatt~cells(2,4)~value = Wechselkurs
tabellenBlatt~cells(3,4)~value = Wechselkurs
tabellenBlatt~cells(2,5)~value = "= B2/D2 "
tabellenBlatt~cells(3,5)~value = "= B3/D2 "

Aktienkursinsert2IBM = IBM_Aktienkurs / FinaleWK



tabellenBlatt~saveAs(directory()"\Umrechnung.xls")

Say "Nun erstellen wir eine Datenbank mit einer Tabelle"

call SysSleep 2


-------------------Creating a database in Microsoft Access.--------------------
/*                                                                    */
/**********************************************************************/

-- This first function just checks to be sure the sample can execute on the
-- current system. Look at the function code at the end of the file for the
-- details. The function returns the oleObject, access application object, on
-- success and .nil if this sample can not run on the current system.
accessApplication = checkSystem()
if accessApplication == .nil then return


dbFileName=directory()"\ooRexxDemo.mdb"                -- define database file name
call createDataBaseFile dbFileName, accessApplication  -- create database file, if necessary

conn=.oleobject~new("ADODB.Connection")   -- create an ADO conncection to the database
conn~provider="Microsoft.Jet.OLEDB.4.0"   -- tell the connection what driver to use

conn~open(dbFileName)            -- open a connection to the database

call dropTable       conn        -- make sure table is dropped
call createTable     conn        -- create a table in the database
call fillTable       conn        -- enter records to the table



conn~close                       -- close connection to the database

call compressAndRepair dbFileName

::requires 'oleUtils.frm'

::routine createDataBaseFile
  use strict arg dbFileName, appAccess

  if stream(dbFileName, "c", "query exists")="" then  -- database file does not exist
  do
     -- We have to know if this is Access 2007 or not. The Jet Engine can not
     -- read the Access 2007 default file format.  So, if this is Access 2007,
     -- we force the database to be created Access 2002-2003 format.

     -- create the database file
     if appAccess~version >= 12 then do
        formatConstant = appAccess~getConstant('acNewDatabaseFormatAccess2002')
        appAccess~NewCurrentDatabase(dbFileName, formatConstant)

        -- With Access 2007, we have to explicitly close the database, or the
        -- Jet Engine can not open it.  Prior to Access 2007, this step is not
        -- needed.
        appAccess~closeCurrentDatabase
     end
     else do
        -- Prior to Access 2007, the NewCurrentDatabase only takes 1 argument.
        appAccess~NewCurrentDatabase(dbFileName)
     end
     say "created database file" pp(dbFileName)
  end
  else
     say "database file" pp(dbFileName) "exists already"

  say center(" end of createDataBaseFile ", 70, "-")
  say

  -- This is the last place in this example where the Access application object
  -- is needed. So we close it now.  All the work is actually done by the Jet
  -- Engine.
  appAccess~quit


::routine dropTable
   use arg conn                  -- retrieve connection to database

   signal on any                 -- intercept any exception
   conn~execute("drop table myTable")     -- execute SQL statement
   say "dropped 'myTable'"
   say center(" end of dropTable ", 70, "-")
   say
   return
any:
   say "could not drop 'myTable'"
   say condition("C") condition("D")
   say center(" end of dropTable ", 70, "-")
   say
   return

::routine createTable
   use arg conn                  -- retrieve connection to database

   sql="create table myTable (Unternehmen text (30), Aktienkurs double, Datum text (30) )"
   say "executing" pp(sql) "..."
   conn~execute(sql)
   say center(" end of createTable ", 70, "-")
   say
--------------------------------------------------------------------------------------------------------------
::routine fillTable 
   use arg conn                  -- retrieve connection to database

---------------------------------------------IBM----------------------------
Explorer = .OLEObject~new("InternetExplorer.Application")
---Explorer~Visible = .true
Explorer~Navigate("http://www.ibm.com/investor/")

/* obtain text representation of the page */
doc = Explorer~document           -- DOM document
body = doc~body                   -- get BODY
textrange = body~CreateTextRange  -- get TextRange
text = textrange~Text             -- get the contents

/* extract stock price information, this is dependent on page not changing */
parse var text . "(NYSE)" '0d0a'x  stockprice "0d0a"x .
if stockprice = "" then do
    stockprice = "<could not read stock price>"
    gotPrice = .false
end
else do
    gotPrice = .true
end

/* end Explorer */
Explorer~quit


parse var stockprice "$" IBM_Aktienkurs
if \ gotPrice then say "Web page has likely changed format."



---------------Microsoft----------------------------------------------------------

myIE = .OLEObject~New("InternetExplorer.Application")

myIE~Width=1500
myIE~Height=1500

--myIE~Visible=.True
myIE~Navigate("https://www.microsoft.com/en-us/investor")
Call SysSleep 3

doc = myIE~document
body=doc~body
textrange=body~CreateTextRange
text=textrange~Text

parse var text . "Microsoft Corp (MSFT)" stockpriceMS "%)" x .
if stockpriceMS = "" then stockpriceMS = "error 404: stock price not found"
myIE~quit

stockpriceMS2 = stockpriceMS"."
parse var stockpriceMS2 "$" MS_Aktienkurs var2

-----Dollar Euro Kurs-------------------------------

myIE = .OLEObject~New("InternetExplorer.Application")

myIE~Width=1500
myIE~Height=1500

---myIE~Visible=.True
myIE~Navigate("https://www.finanzen.at/devisen/dollarkurs")
Call SysSleep 3

doc = myIE~document
body=doc~body
textrange=body~CreateTextRange
text=textrange~Text

parse var text . "(EUR - USD)" ex_rate "USD" x .
if ex_rate = "" then ex_rate = "error 404: exchange rate not found"
myIE~quit

parse var ex_rate name1 10 Wechselkurs 6

parse var Wechselkurs before "," after 

FinaleWK = before"."after


Unternehmeninsert ="IBM"
Aktienkursinsert = IBM_Aktienkurs / FinaleWK
Datuminsert = DATE()

Unternehmeninsert2 ="Microsoft"
Aktienkursinsert2 = MS_Aktienkurs / FinaleWK

-------------------------------------------------------------------------


sql="insert into myTable (Unternehmen, Aktienkurs, Datum) values ('"Unternehmeninsert"', "Aktienkursinsert", '"Datuminsert"' )"
sql2="insert into myTable (Unternehmen, Aktienkurs, Datum) values ('"Unternehmeninsert2"', "Aktienkursinsert2", '"Datuminsert"' )"

conn~execute(sql)            -- execute the statement
conn~execute(sql2)
   say center(" end of fillTable ", 70, "-")
   say


::routine showTable
   use arg conn                  -- retrieve connection to database

 
   sql="select * from myTable"
   conn~execute(sql)
   
   say center(" end of showTable ", 70, "-")
   say

::routine deleteAndShow
   use arg conn                  -- retrieve connection to database

   say "deleting a record from the table:"
   say
      -- delete row with an arbitrary value for the field "id"
   sql="delete from myTable where id="random(1,.tmp.nrRecs)
   say "   executing" pp(sql) "..."
   conn~execute(sql)
   say

   .local~tmp.nrRecs=.tmp.nrRecs-1        -- subtract 1 from total number of records
   .local~tmp.length=length(.tmp.nrRecs)  -- save length

   call showTable   conn         -- show presently stored records

::routine updateAndShow
   use arg conn                  -- retrieve connection to database

   say "updating a few records from the table:"
   say
      -- update some records randomly
   sql="update myTable set id=id*3 where id >" random(1,.tmp.nrRecs)
   say "   executing" pp(sql) "..."
   param = .OLEVariant~new(count)
   conn~execute(sql, param)
   say "  " pp(param~!varValue_) "record(s) affected."
   say

   call showTable   conn            -- show presently stored records


::routine compressAndRepair      -- Jet (= MS Access) databases tend to grow considerably
  parse arg dbFileName

  say "before compress & repair, database file size:" pp(stream(dbFileName, "c", "query size"))
  compressedName=SysTempFileName(dbFileName"-cmp???") -- get a unique new file name

/*
   -- Hint: if your MDB-database is secured with a database password, you must supply
   --       that password in the variable "pw":

  if pw="" then pwdString=""
           else pwdString=";Jet OLEDB:Database Password="pw

  fromString="Provider=Microsoft.Jet.OLEDB.4.0;Data Source="dbFileName     || pwdString
  toString  ="Provider=Microsoft.Jet.OLEDB.4.0;Data Source="compressedName || pwdString
*/

   -- Hint: MDB database files have no database password set
  fromString="Provider=Microsoft.Jet.OLEDB.4.0;Data Source="dbFileName
  toString  ="Provider=Microsoft.Jet.OLEDB.4.0;Data Source="compressedName


  jro=.oleObject~new("JRO.JetEngine")
  jro~compactDatabase(fromString, toString)     -- carry out compact & repair
  say "after  compress & repair, database file size:" pp(stream(compressedName, "c", "query size"))

      -- create a unique backup file name containing date and time of backup
  newBkpFileName=dbFileName"-bkp-"date("S")"-"time()~changestr(":","")

  say "renaming work files..."
      -- rename original database file name to backup file name
  cmdText="ren" '"'dbFileName'"' filespec("Name", newBkpFileName)
  say "DOS command:" pp(cmdText)
  address cmd cmdText               -- use ADDRESS CMD explicitly

      -- now rename new compressed file to original databse file name
  cmdText="ren" '"'compressedName'"' filespec("Name", dbFileName)
  say "DOS command:" pp(cmdText)
  cmdText                           -- this uses ADDRESS CMD implicitly
  say center(" end of compressAndRepair ", 70, "-")
   say


::routine pp
   return "[" || arg(1) || "]"

::routine checkSystem

   mode = getAddressingMode()
   if mode == 64 then do
      say
      say 'You are running a 64-bit compiled ooRexx'
      say
      say 'This sample relies on the Microsoft Jet Database Engine.'
      say 'There is no 64-bit version of Jet, therefore a 64-bit'
      say 'compiled ooRexx can not run this sample.  This sample'
      say 'may be upgraded in the future to work with Access 2007'
      say 'and its Microsoft Access Engine (ACE).  ACE is also'
      say '32-bit. It is not clear at the current time whether ACE'
      say 'will be ported to 64-bit.'
      say
      say 'Sorry, this sample is 32-bit only.'

      return .nil
   end

   -- We have to have Access, exit gracefully if not.
   accessApplication = createOleObject("Access.Application", .true)
   if accessApplication == .nil then do
      say
      say 'This example requires Microsoft Access, which does not seem'
      say 'to be installed.  Quitting.'
   end

   return accessApplication